﻿using InnoLabProjektDektopApp.Services;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Security.Policy;
using System.Text;
using System.Text.Json;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Automation.Text;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Forms.VisualStyles;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace InnoLabProjektDektopApp.Screens.Regulaer
{
    /// <summary>
    /// Interaction logic for Mascott.xaml
    /// </summary>
    public partial class Mascott : Window
    {
        private Timer frameTimer;
        private Timer animationTimer;
        private int frameCounter = 1;
        private int distractionStage = 1;
        private string framePath = "";
        private int oldDistractionStage = 4;
        private string animationDirection = "Down";

        ProcessMonitor processMonitor;

        public Mascott()
        {

            if (!mascottVisible())
            {
                MascottImage.Visibility = Visibility.Hidden;
                return;
            }

            InitializeComponent();
            emotionUp();

            processMonitor = App.GetProcessMonitor();
            this.Left = -30; //SystemParameters.PrimaryScreenWidth - this.Width;
            this.Top = SystemParameters.PrimaryScreenHeight - this.Height - 30;

            animationTimer = new Timer(animationTick, null, 0, 4000);
        }


        private void animationTick(object state)
        {
            Application.Current.Dispatcher.Invoke(() =>
            {
                /*
                if (!processMonitor.isMonitoring) processMonitor.StartMonitoring();

                DateTime timeLeft = Overview.getSessionInstance().timeLeft();
                int processMonitorStage = processMonitor.CalculateCurrentDistractionStage(timeLeft);
                
                if (processMonitorStage == oldDistractionStage) {
                    Counterxd.Text = "x: " + processMonitorStage.ToString();
                    return;
                }

                if (processMonitorStage < oldDistractionStage) {
                    emotionUp();
                } else if(processMonitorStage > oldDistractionStage) {
                    emotionDown();
                }
                
                oldDistractionStage = processMonitorStage;*/
            });
        }

        public void emotionDown() { 
            if (animationDirection == "Down") distractionStage--;
            if (distractionStage < 1) {
                distractionStage = 1;
                return;
            }
            animationDirection = "Down";
            frameCounter = 1;

            Counterxd.Text = distractionStage.ToString();
            frameTimer = new Timer(frameTick, null, 0, 42);
        }

        public void emotionUp() {
            if (animationDirection == "Up") distractionStage++;
            if (distractionStage > 7) {
                distractionStage = 7;
                return;
            }
            animationDirection = "Up";
            frameCounter = 1;

            Counterxd.Text = distractionStage.ToString();
            frameTimer = new Timer(frameTick, null, 0, 42);
        }

        private void frameTick(object state)
        {

            Application.Current.Dispatcher.Invoke(() =>
            { 
                framePath = $"pack://application:,,,/Assets/MascottAnimation/{animationDirection}/{distractionStage}/frame{frameCounter}.png";

                bool sucessfulySet = setFrame();

                if (!sucessfulySet)
                {
                    frameTimer.Dispose();
                    ellipse1.Fill = Brushes.Red;
                } else {
                    ellipse1.Fill = Brushes.Lime;
                }

                    frameCounter++;
            });
        }

        private bool setFrame() //returns, if the frame was sucessfuly set
        {
            try
            {
                //MascottImage.Source = new BitmapImage(new Uri($"pack://application:,,,/Assets/MascottAnimation/Down/{animation}/frame{frame_}.png"));
                MascottImage.Source = new BitmapImage(new Uri(framePath));
            }
            catch (Exception e) {
                return false;
            }

            return true;
        }

        private bool mascottVisible()
        { 
            String profile = "profile1";
            String SettingsFilePath = System.IO.Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "settings.json");

            if (File.Exists(SettingsFilePath))
            {
                string jsonContent = File.ReadAllText(SettingsFilePath);
                var settings = JsonSerializer.Deserialize<Dictionary<string, JsonElement>>(jsonContent);

                if (settings != null && settings.ContainsKey(profile))
                {
                    var profileSettings = settings[profile];

                    if (profileSettings.TryGetProperty("mascotVisibility", out var mascotVisibilityElement))
                    {

                        string mascotVisibility = mascotVisibilityElement.GetString();
                        if (mascotVisibility.Equals("Yes"))
                        {
                            return true;
                        }
                    }
                }
            }

            return false;
        }

        private void Window_MouseDown(object sender, MouseButtonEventArgs e)
        {
            if (e.ChangedButton == MouseButton.Left)
                this.DragMove();
        }

        private void Window_LocationChanged(object sender, EventArgs e)
        {
            // Prevent the window from moving too close to the edges
            if (this.Left < -30)
                this.Left = -30;
            if (this.Top < 0)
                this.Top = 0;
            if (this.Left + this.Width > SystemParameters.PrimaryScreenWidth)
                this.Left = SystemParameters.PrimaryScreenWidth - this.Width;
            if (this.Top + this.Height > SystemParameters.PrimaryScreenHeight - 30)
                this.Top = SystemParameters.PrimaryScreenHeight - this.Height -30;
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            processMonitor.StopMonitoring();
        }
    }
}
